; TEST FILE FOR 8085/Z80 ASSEMBLER
;
; Copyright (C) 1983 by Avocet Systems, Inc.  All Rights Reserved. 
;
; Release 1.0	12/20/83	JLZ


	ORG	100H
	.Z80
;
; LD Instruction
;

	mov	A,A
	mov	A,B
	MOV	A,C
	MOV	A,D
	MOV	A,E
	MOV	A,H
	MOV	A,L
	MOV	A,M
	MOV	A,0(X)
	MOV	A,5(X)
	MOV	A,0(Y)
	MOV	A,-2(Y)

	MOV	B,A
	MOV	B,B
	MOV	B,C
	MOV	B,D
	MOV	B,E
	MOV	B,H
	MOV	B,L
	MOV	B,M
	MOV	B,0(X)
	MOV	B,5(X)
	MOV	B,0(Y)
	MOV	B,-2(Y)

	MOV	C,A
	MOV	C,B
	MOV	C,C
	MOV	C,D
	MOV	C,E
	MOV	C,H
	MOV	C,L
	MOV	C,M
	MOV	C,0(X)
	MOV	C,5(X)
	MOV	C,0(Y)
	MOV	C,-2(Y)

	MOV	D,A
	MOV	D,B
	MOV	D,C
	MOV	D,D
	MOV	D,E
	MOV	D,H
	MOV	D,L
	MOV	D,M
	MOV	D,0(X)
	MOV	D,5(X)
	MOV	D,0(Y)
	MOV	D,-2(Y)

	MOV	E,A
	MOV	E,B
	MOV	E,C
	MOV	E,D
	MOV	E,E
	MOV	E,H
	MOV	E,L
	MOV	E,M
	MOV	E,0(X)
	MOV	E,5(X)
	MOV	E,0(Y)
	MOV	E,-2(Y)

	MOV	H,A
	MOV	H,B
	MOV	H,C
	MOV	H,D
	MOV	H,E
	MOV	H,H
	MOV	H,L
	MOV	H,M
	MOV	H,0(X)
	MOV	H,5(X)
	MOV	H,0(Y)
	MOV	H,-2(Y)

	MOV	L,A
	MOV	L,B
	MOV	L,C
	MOV	L,D
	MOV	L,E
	MOV	L,H
	MOV	L,L
	MOV	L,M
	MOV	L,0(X)
	MOV	L,5(X)
	MOV	L,0(Y)
	MOV	L,-2(Y)

	MOV	M,A
	MOV	M,B
	MOV	M,C
	MOV	M,D
	MOV	M,E
	MOV	M,H
	MOV	M,L

	MOV	0(X),A
	MOV	0(X),B
	MOV	0(X),C
	MOV	0(X),D
	MOV	0(X),E
	MOV	0(X),H
	MOV	0(X),L

	MOV	5(X),A
	MOV	5(X),B
	MOV	5(X),C
	MOV	5(X),D
	MOV	5(X),E
	MOV	5(X),H
	MOV	5(X),L

	MOV	0(Y),A
	MOV	0(Y),B
	MOV	0(Y),C
	MOV	0(Y),D
	MOV	0(Y),E
	MOV	0(Y),H
	MOV	0(Y),L

	MOV	-2(Y),A
	MOV	-2(Y),B
	MOV	-2(Y),C
	MOV	-2(Y),D
	MOV	-2(Y),E
	MOV	-2(Y),H
	MOV	-2(Y),L

	MVI	A,0
	MVI	B,2
	MVI	C,5
	MVI	D,0
	MVI	E,-1
	MVI	H,10
	MVI	L,0
	MVI	M,254
	MVI	0(X),1
	MVI	0(Y),1
	MVI	5(X),1
	MVI	-2(Y),1

	LDAX	B
	LDAX	D
	STAX	B
	STAX	D
	STA	1234H
	LDA	1234H

	LDAI
	LDAR
	STAI
	STAR

	LXI	B,1234H
	LXI	D,1234H
	LXI	H,1234H
	LXI	SP,1234H
	LXI	X,1234H
	LXI	Y,1234H

	LBCD	1234H	;
	LDED	1234H	; comment
	LHLD	1234H
	LSPD	1234H
	LIXD	1234H
	LIYD	1234H

	SBCD	1234H
	SDED	1234H
	SHLD	1234H
	SSPD	1234H
	SIXD	1234H
	SIYD	1234H

	SPHL
	SPIX
	SPIY



;
; PUSH AND POP
;

	PUSH	B
	PUSH	D
	PUSH	H
	PUSH	PSW
	PUSH	X
	PUSH	Y

	POP	B
	POP	D
	POP	H
	POP	PSW
	POP	X
	POP	Y

;
; EXCHANGES
;

	XCHG
	EXAF
	EXX

;
; BLOCK MOVES
;

	LDI
	LDIR
	LDD
	LDDR
	CCI
	CCIR
	CCD
	CCDR

;
; ARITHMETIC AND LOGIC
;

	ADD	A
	ADD	B
	ADD	C
	ADD	D
	ADD	E
	ADD	H
	ADD	L
	ADD	M
	ADD	5(X)
	ADD	0(Y)
	ADI	17H

	DAD	B
	DAD	D
	DAD	H
	DAD	SP

	DADX	B
	DADX	D
	DADX	SP
	DADX	X

	DADY	B
	DADY	D
	DADY	SP
	DADY	Y

	ADC	A
	ADC	B
	ADC	C
	ADC	D
	ADC	E
	ADC	H
	ADC	L
	ADC	M	;comment
	ADC	5(X)	;comment
	ADC	0(Y)
	ACI	17H

	DADC	B
	DADC	D
	DADC	H
	DADC	SP

	SBB	A
	SBB	B
	SBB	C
	SBB	D
	SBB	E
	SBB	H
	SBB	L
	SBB	M
	SBB	5(X)
	SBB	0(Y)
	SBI	17H

	DSBC	B
	DSBC	D
	DSBC	H
	DSBC	SP

	SUB	A
	SUB	B
	SUB	C
	SUB	D
	SUB	E
	SUB	H
	SUB	L
	SUB	M
	SUB	5(X)
	SUB	0(Y)
	SUI	17H

	ANA	A
	ANA	B
	ANA	C
	ANA	D
	ANA	E
	ANA	H
	ANA	L
	ANA	M
	ANA	5(X)
	ANA	0(Y)
	ANI	17H

	XRA	A
	XRA	B
	XRA	C
	XRA	D
	XRA	E
	XRA	H
	XRA	L
	XRA	M
	XRA	5(X)
	XRA	0(Y)
	XRI	17H

	ORA	A
	ORA	B
	ORA	C
	ORA	D
	ORA	E
	ORA	H
	ORA	L
	ORA	M
	ORA	5(X)
	ORA	0(Y)
	ORI	17H

	CMP	A
	CMP	B
	CMP	C
	CMP	D
	CMP	E
	CMP	H
	CMP	L
	CMP	M
	CMP	5(X)
	CMP	0(Y)
	CPI	17H

	INR	A
	INR	B
	INR	C
	INR	D
	INR	E
	INR	H
	INR	L
	INR	M
	INR	5(X)
	INR	0(Y)

	INX	B
	INX	D
	INX	H		;comment
	INX	SP
	INX	X
	INX	Y

	DCR	A		;comment
	DCR	B
	DCR	C
	DCR	D
	DCR	E
	DCR	H
	DCR	L
	DCR	M
	DCR	5(X)
	DCR	0(Y)

	DCX	B
	DCX	D
	DCX	H
	DCX	SP
	DCX	X
	DCX	Y

;
; CONTROL INSTRUCTIONS
;

	DAA
	CMA
	NEG
	CMC
	STC
	NOP
	HLT
	DI
	EI
	IM0
	IM1
	IM2

;
; SHIFTS AND ROTATES
;

	RLC
	RRC
	RAL
	RAR
	RLD
	RRD

	RLCR	A
	RLCR	B
	RLCR	C
	RLCR	D
	RLCR	E
	RLCR	H
	RLCR	L
	RLCR	M
	RLCR	2(X)
	RLCR	-2(Y)

	RRCR	A
	RRCR	B
	RRCR	C
	RRCR	D
	RRCR	E
	RRCR	H
	RRCR	L
	RRCR	M
	RRCR	2(X)
	RRCR	-2(Y)

	RALR	A
	RALR	B
	RALR	C
	RALR	D
	RALR	E
	RALR	H
	RALR	L
	RALR	M
	RALR	2(X)
	RALR	-2(Y)

	RARR	A
	RARR	B
	RARR	C
	RARR	D
	RARR	E
	RARR	H
	RARR	L
	RARR	M
	RARR	2(X)
	RARR	-2(Y)

	SLAR	A
	SLAR	B
	SLAR	C
	SLAR	D
	SLAR	E
	SLAR	H
	SLAR	L
	SLAR	M
	SLAR	2(X)
	SLAR	-2(Y)

	SRAR	A
	SRAR	B
	SRAR	C
	SRAR	D
	SRAR	E
	SRAR	H
	SRAR	L
	SRAR	M
	SRAR	2(X)
	SRAR	-2(Y)

	SRLR	A
	SRLR	B
	SRLR	C
	SRLR	D
	SRLR	E
	SRLR	H
	SRLR	L
	SRLR	M
	SRLR	2(X)
	SRLR	-2(Y)

;
; BIT MANIPULATION
;


	BIT	0,A
	BIT	1,A
	BIT	2,A
	BIT	3,A
	BIT	4,A
	BIT	5,A
	BIT	6,A
	BIT	7,A

	BIT	0,B
	BIT	1,B
	BIT	2,B
	BIT	3,B
	BIT	4,B
	BIT	5,B
	BIT	6,B
	BIT	7,B

	BIT	0,C
	BIT	1,C
	BIT	2,C
	BIT	3,C
	BIT	4,C
	BIT	5,C
	BIT	6,C
	BIT	7,C

	BIT	0,D
	BIT	1,D
	BIT	2,D
	BIT	3,D
	BIT	4,D
	BIT	5,D
	BIT	6,D
	BIT	7,D

	BIT	0,E
	BIT	1,E
	BIT	2,E
	BIT	3,E
	BIT	4,E
	BIT	5,E
	BIT	6,E
	BIT	7,E

	BIT	0,H
	BIT	1,H
	BIT	2,H
	BIT	3,H
	BIT	4,H
	BIT	5,H
	BIT	6,H
	BIT	7,H

	BIT	0,L
	BIT	1,L
	BIT	2,L
	BIT	3,L
	BIT	4,L
	BIT	5,L
	BIT	6,L
	BIT	7,L

	BIT	0,M
	BIT	1,M
	BIT	2,M
	BIT	3,M
	BIT	4,M
	BIT	5,M
	BIT	6,M
	BIT	7,M

	BIT	0,5(X)
	BIT	1,5(X)
	BIT	2,5(X)
	BIT	3,5(X)
	BIT	4,5(X)
	BIT	5,5(X)
	BIT	6,5(X)
	BIT	7,5(X)

	BIT	0,0(Y)
	BIT	1,0(Y)
	BIT	2,0(Y)
	BIT	3,0(Y)
	BIT	4,0(Y)
	BIT	5,0(Y)
	BIT	6,0(Y)
	BIT	7,0(Y)


	RES	0,A
	RES	1,A
	RES	2,A
	RES	3,A
	RES	4,A
	RES	5,A
	RES	6,A
	RES	7,A

	RES	0,B
	RES	1,B
	RES	2,B
	RES	3,B
	RES	4,B
	RES	5,B
	RES	6,B
	RES	7,B

	RES	0,C
	RES	1,C
	RES	2,C
	RES	3,C
	RES	4,C
	RES	5,C
	RES	6,C
	RES	7,C

	RES	0,D
	RES	1,D
	RES	2,D
	RES	3,D
	RES	4,D
	RES	5,D
	RES	6,D
	RES	7,D

	RES	0,E
	RES	1,E
	RES	2,E
	RES	3,E
	RES	4,E
	RES	5,E
	RES	6,E
	RES	7,E

	RES	0,H
	RES	1,H
	RES	2,H
	RES	3,H
	RES	4,H
	RES	5,H
	RES	6,H
	RES	7,H

	RES	0,L
	RES	1,L
	RES	2,L
	RES	3,L
	RES	4,L
	RES	5,L
	RES	6,L
	RES	7,L

	RES	0,M
	RES	1,M
	RES	2,M
	RES	3,M
	RES	4,M
	RES	5,M
	RES	6,M
	RES	7,M

	RES	0,5(X)
	RES	1,5(X)
	RES	2,5(X)
	RES	3,5(X)
	RES	4,5(X)
	RES	5,5(X)
	RES	6,5(X)
	RES	7,5(X)

	RES	0,0(Y)
	RES	1,0(Y)
	RES	2,0(Y)
	RES	3,0(Y)
	RES	4,0(Y)
	RES	5,0(Y)
	RES	6,0(Y)
	RES	7,0(Y)


	SET	0,A
	SET	1,A
	SET	2,A
	SET	3,A
	SET	4,A
	SET	5,A
	SET	6,A
	SET	7,A

	SET	0,B
	SET	1,B
	SET	2,B
	SET	3,B
	SET	4,B
	SET	5,B
	SET	6,B
	SET	7,B

	SET	0,C
	SET	1,C
	SET	2,C
	SET	3,C
	SET	4,C
	SET	5,C
	SET	6,C
	SET	7,C

	SET	0,D
	SET	1,D
	SET	2,D
	SET	3,D
	SET	4,D
	SET	5,D
	SET	6,D
	SET	7,D

	SET	0,E
	SET	1,E
	SET	2,E
	SET	3,E
	SET	4,E
	SET	5,E
	SET	6,E
	SET	7,E

	SET	0,H
	SET	1,H
	SET	2,H
	SET	3,H
	SET	4,H
	SET	5,H
	SET	6,H
	SET	7,H

	SET	0,L
	SET	1,L
	SET	2,L
	SET	3,L
	SET	4,L
	SET	5,L
	SET	6,L
	SET	7,L

	SET	0,M
	SET	1,M
	SET	2,M
	SET	3,M
	SET	4,M
	SET	5,M
	SET	6,M
	SET	7,M

	SET	0,5(X)
	SET	1,5(X)
	SET	2,5(X)
	SET	3,5(X)
	SET	4,5(X)
	SET	5,5(X)
	SET	6,5(X)
	SET	7,5(X)

	SET	0,0(Y)
	SET	1,0(Y)
	SET	2,0(Y)
	SET	3,0(Y)
	SET	4,0(Y)
	SET	5,0(Y)
	SET	6,0(Y)
	SET	7,0(Y)

;
; JUMPS, CALLS, AND RETURNS
;

	JMP	1234H		;comment
	JNZ	4455H	;comment
	JZ	4455H
	JNC	4455H
	JC	1234H
	JPO	1234H
	JPE	1234H
	JP	1234H
	JM	1234H
;	JO	1234H
;	JNO	1234H

	PCHL
	PCIX
	PCIY

	CALL	1234H
	CNZ	4455H
	CZ	4455H
	CNC	4455H
	CC	1234H
	CPO	1234H
	CPE	1234H
	CP	1234H
	CM	1234H
;	CO	1234H
;	CNO	1234H

	RET		;comment
	RNZ
	RZ
	RNC
	RC
	RPO
	RPE
	RP
	RM
;	RO
;	RNO

	RETI
	RETN

	JMPR	$
	JRNZ	$
	JRZ	$
	JRNC	$
	JRC	$

	DJNZ	$

	RST 	0
	RST	1
	RST	2
	RST	3
	RST	4
	RST	5
	RST	6
	RST	7

;
; INPUT/OUTPUT
;

	IN	5	;comment
	IN	7

	INP	A	;comment
	INP	B
	INP	C
	INP	D
	INP	E
	INP	H
	INP	L

	INI
	INIR
	IND
	INDR

	OUT	5
	OUT	7

	OUTP	A
	OUTP	B
	OUTP	C
	OUTP	D
	OUTP	E
	OUTP	H
	OUTP	L

	OUTI
	OUTIR
	OUTD
	OUTDR


	END
